import com.sun.org.apache.xml.internal.serialize.LineSeparator;

import java.util.LinkedList;

/*
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
Verwenden Sie die gegebenen Testklassen zum Überprüfen Ihrer Lösung. Die Korrektheit dieser Testfälle
ist notwendig, aber nicht hinreichend für eine korrekte Lösung. Es werden damit nur bestimmte
Spezialfälle geprüft. Liefern die Testklassen keinen Fehler, garantiert dies noch nicht die
Korrektheit Ihrer Lösung gemäß der Angabe.
*/
public class Aufgabe1 {

    /*
    Aufgabe: Umgang mit Klassen und Objekten, sowie vorgefertigten Datenstrukturen.

        Ergänzen Sie fehlende Teile der Klassen 'Position' und 'Minefield' entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 40):
        12 Punkte in Summe für Klasse 'Position':
            3 Punkte für Konstruktoren und Objektvariablen
            2 Punkte für 'moveVertical'
            4 Punkte für 'isNeighbour'
            3 Punkte für 'equals' und 'hashCode',
        28 Punkte für Klasse 'Minefield':
            3 Punkte für den Konstruktor
            5 Punkte für 'isBomb'
            5 Punkte für 'setBomb'
            5 Punkte für 'trim'
            5 Punkte für 'toString'
            5 Punkte für 'copy'

    Auch für teilweise korrekte Lösungen werden Punkte vergeben.

    */
    


    // Diese Methode können Sie zum Testen nutzen. Sie geht nicht in die Beurteilung ein.
    public static void main(String[] args) {

        //Testen von Position:
        Position p = new Position(1,2);

        for (int x = 0; x < 5; x++) {
            for (int y = 0; y < 5; y++) {
                if ((x == 1 && y == 2) != new Position(x,y).equals(p)) {
                    System.out.println("Fehler in Klasse 'Position'!");
                }
            }
        }

        //Testen von Minefield:
        Minefield f = new Minefield(10, 13);
        System.out.println(f.setBomb(3, 2));
        System.out.println(f.setBomb(5, 3));
        System.out.println(f.setBomb(4, 5));
        System.out.println(f.setBomb(6, 5));
        System.out.println(f.setBomb(4, 9));
        System.out.println(f.setBomb(3, 2));
        System.out.println(f.setBomb(9, 9));
        System.out.println();
        System.out.println(f);
        Minefield g = f.copy();
        f.trim();
        System.out.println();
        System.out.println(f);
        System.out.println();
        System.out.println(g);
        /* Erwartete Ausgabe:

        true
        true
        true
        true
        true
        false
        true

        0000000000
        0011100000
        001*211000
        00112*1000
        0001232100
        0001*2*100
        0001121100
        0000000000
        0001110011
        0001*1001*
        0001110011
        0000000000
        0000000000
        10 13

        001*211000
        00112*1000
        0001232100
        0001*2*100
        0001121100
        0000000000
        0001110011
        0001*1001*
        10 8

        0000000000
        0011100000
        001*211000
        00112*1000
        0001232100
        0001*2*100
        0001121100
        0000000000
        0001110011
        0001*1001*
        0001110011
        0000000000
        0000000000
        10 13

        */


    }
}

// Diese Klasse repräsentiert eine 2D-Position mit 2 Koordinaten.
// Es kann davon ausgegangen werden, dass beide Koordinaten größer oder gleich 0 sind.
class Position {

    //TODO: Deklarieren Sie entsprechende Variablen.
    private int x,y;

    // Initialisiert diese Position mit den angegebenen Koordinaten x und y.
    // Annahme: x >= 0 und y >= 0.
    public Position(int x, int y) {
        if(x<0||y<0){
            x=0;
            y=0;
        }
        this.x=x;
        this.y=y;
        //TODO: Implementieren Sie diesen Konstruktor

    }

    // Initialisiert diese Position mit den Koordinaten von 'p'.
    public Position(Position p) {
        //TODO: Implementieren Sie diesen Konstruktor
        x=p.x;
        y=p.y;

    }

    // Erhöht die y-Koordinate der Position um 'deltaY'.
    // Wird die y-Koordinate dadurch negativ wird sie 0 gesetzt.
    public void moveVertical(int deltaY) {
        //TODO: Implementieren Sie diese Methode

        y+=deltaY;

        if(y<0){
            y=0;
        }


    }

    @Override
    // Die equals-Methode: Überprüft die Gleichheit mit einem anderen
    // Objekt 'o'. Diese Methode kann für die
    // Implementierung der anderen Klassen benutzt werden.
    // liefert true, wenn das angegebene Objekt 'o' eine Position mit
    // den gleichen Koordinaten wie diese Position ist, sonst false.
    public boolean equals(Object o) {

        if (o == null) {
            return false;
        }

        if (o.getClass() != Position.class) {
            return false;
        }

        Position p = (Position) o;

        if(p.x==x&&p.y==y){
            return true;
        }

        //TODO: Vervollständigen Sie diese Methode
        return false; //TODO: Diese Zeile entfernen oder entsprechend ändern

    }

    // Liefert den Hashcode dieser Position. Dieser entspricht
    // der x-Koordinate der Position.
    public int hashCode() {
        //TODO: Vervollständigen Sie diese Methode
        return x; //TODO: Diese Zeile entfernen oder entsprechend ändern

    }

    // Liefert true, wenn die angegebene Position innerhalb der
    // Achter-Nachbarschaft dieser Position liegt, sonst false.
    // (Zwei Positionen sind in diesem Sinn benachbart, wenn
    // sie in waagrechter oder senkrechter oder diagonaler Richtung
    // benachbart sind).
    public boolean isNeighbour(Position p) {


        //TODO: Vervollständigen Sie diese Methode
        return (x+1>=p.x&&x-1<=p.x) && (y+1>=p.y&&y-1<=p.y); //TODO: Diese Zeile entfernen oder entsprechend ändern


    }

}

// Diese Klasse repräsentiert ein rechteckiges Minenfeld (analog zum Spiel "Minesweeper"
// ohne Spielzüge).
// In diesem Minenfeld werden die Positionen von Bomben gespeichert.
// (0,0) ist die Position links oben im Spielfeld.
class Minefield {

    // Deklarieren Sie hier keine weiteren globalen/Objekt- Variablen.
    // Innerhalb der Methoden können natürlich lokale Variablen genutzt werden.
    private LinkedList<Position> bombs;
    private int width;
    private int height;

    // Initialisiert dieses Minenfeld als leeres Minenfeld
    // (d.h. anfangs sind keine Bomben enthalten)
    // 'width' ist die Breite des Minenfelds (horizontal)
    // und 'height' die Höhe (vertikal).
    public Minefield(int width, int height) {
        bombs = new LinkedList<>();
        this.width=width;
        this.height=height;

        //TODO: Implementieren Sie diese Methode

    }

    // Liefert true, wenn an der angegebenen
    // Position eine Bombe liegt, sonst false.
    public boolean isBomb(int x, int y) {

        for (Position p: bombs) {
            if((new Position(x,y).equals(p))){
                return true;
            }
        }


        //TODO: Implementieren Sie diese Methode
        return false; //TODO: Diese Zeile entfernen oder entsprechend ändern

    }

    // Setzt eine neue Bombe durch Angabe von Koordinaten. Eine Bombe wird nur dann gesetzt,
    // wenn die Position innerhalb des Minenfelds liegt und sich an dieser
    // Position noch keine Bombe befindet.
    // Liefert true, falls eine neue Bombe platziert wurde, sonst false.
    public boolean setBomb(int x, int y) {

        if(x>=0&&y>=00&&x<width&&y<height){

            if(!isBomb(x,y)){

                bombs.add(new Position(x,y));
                return true;
            }
        }

        //TODO: Implementieren Sie diese Methode
        return false; //TODO: Diese Zeile entfernen oder entsprechend ändern

    }

    // Liefert die Anzahl der Bomben, die sich in der Achter-Nachbarschaft der
    // angegebenen Position befinden.
    public int bombNeighbours(int x, int y) {
        int count=0;

        for (Position p: bombs) {
            if((new Position(x,y)).isNeighbour(p)){
                count++;
            }
        }

        //TODO: Implementieren Sie diese Methode
        return count; //TODO: Diese Zeile entfernen oder entsprechend ändern

    }

    @Override
    // Gibt das Minenfeld als vollständiges lesbares rechteckiges
    // Raster mit entsprechender Größe aus (d.h. ein String mit 'height' Zeilen
    // der Breite 'width'), wobei hier alle Bomben durch '*' dargestellt werden.
    // An allen anderen Positionen wird die Anzahl der Bomben in
    // deren Nachbarschaft eingezeichnet.
    // Unterhalb des Rasters soll in einer eigenen Zeile die Breite gefolgt
    // von der Höhe ausgegeben werden.
    public String toString() {

        String s = "";

        for (int iy=0;iy<height;iy++){

            for(int ix=0; ix<width;ix++){
                if(isBomb(ix,iy)){
                    s+="*";
                } else{
                    s+=bombNeighbours(ix,iy);
                }
            }
            s+= System.lineSeparator();
        }
        s+=width+" "+height;

        //TODO: Implementieren Sie diese Methode
        return s; //TODO: Diese Zeile entfernen oder entsprechend ändern

    }

    // Entfernt alle Zeilen am oberen und am unteren Ende des Minenfelds
    // in dem keine Bomben liegen.
    // Da die oberste Zeile des verkleinerten Minenfelds im Allgemeinen nicht
    // mit der des ursprünglichen Minenfelds übereinstimmt (siehe Beispiele),
    // müssen auch die Positionen der Bomben modifiziert werden.
    // HINWEIS: Nutzen Sie nach Moeglichkeit Methoden von 'Position'.
    // Beachten Sie hierbei auch, 'height' zu aktualisieren.
    public void trim() {
        boolean bombinRow=false;
        int delta =0;

        for (int iy=height-1;iy>=0;iy--){


            for (Position p: bombs) {
                if(p.y==iy){
                    bombinRow=true;
                }
            }

            if(!bombinRow){
                delta++;
            } else {
                break;
            }

            bombinRow=false;

        }

        height-=delta;

        delta=0;
        bombinRow=false;

        int moveDelta= 0;

        for (int iy=0;iy<height;iy++){


            for (Position p: bombs) {
                if(p.y==iy){
                    bombinRow=true;
                }
            }

            if(!bombinRow){
                delta++;
            } else {
                break;
            }

            bombinRow=false;
        }

        for (Position p: bombs) {
            if(p.y>delta){
                p.moveVertical(-delta);
            }
        }

        height-=delta;


    }

    // Liefert eine unabhängige Kopie dieses Minenfeldes. Sollte diese
    // Kopie später geändert werden (z.B. mit trim), soll das keine Auswirkungen auf das
    // Original haben und umgekehrt.
    public Minefield copy() {

        Minefield m = new Minefield(width,height);

        for (Position p: bombs) {
            m.setBomb(p.x,p.y);
        }

        //TODO: Implementieren Sie diese Methode
        return m; //TODO: Diese Zeile entfernen oder entsprechend ändern

    }
}
